//
//  ViewController.h
//  IVBricker
//
//  Created by Bob on 13-1-28.
//  Copyright (c) 2013年 Bob. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/CADisplayLink.h>

@interface ViewController : UIViewController <UIAccelerometerDelegate> {
    int score;
    float touchOffset;
    CGPoint ballMovement;
    
    UILabel *scoreLabel;
    UIImageView *ball;
    UIImageView *paddle;
    
    int lives;
    UILabel *livesLabel;
    UILabel * messageLabel;
    
    BOOL isPlaying;
    // NSTimer *theTimer;
    CADisplayLink *theTimer;
    
    #define BRICKS_WIDTH 5
    #define BRICKS_HEIGHT  4
    
    UIImageView *bricks[BRICKS_WIDTH][BRICKS_HEIGHT];
    NSString *brickTypes[4];
}

@property(nonatomic, retain) IBOutlet UILabel *scoreLabel;
@property(nonatomic, retain) IBOutlet UIImageView *ball;
@property(nonatomic, retain) IBOutlet UIImageView *paddle;

@property(nonatomic, retain) IBOutlet UILabel *livesLabel;
@property(nonatomic, retain) IBOutlet UILabel *messagesLabel;

- (void) initializeTimer;
- (void) gameLogic:(NSTimer *)theTimer;

- (void) startPlaying;
- (void) pauseGame;

- (void) initializeBricks;

- (void) processCollision:(UIImageView *)brick;

- (void) saveGameState;
- (void) loadGameState;

@end
