//
//  ViewController.m
//  IVBricker
//
//  Created by Bob on 13-1-28.
//  Copyright (c) 2013年 Bob. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize scoreLabel;
@synthesize ball;
@synthesize paddle;
@synthesize livesLabel;
@synthesize messagesLabel;

// 将该函数放在生成器下面是好习惯
- (void) dealloc{
    [scoreLabel release];
    [ball release];
    [paddle release];
    [livesLabel release];
    [messagesLabel release];
    
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    UIAccelerometer *theAccel = [UIAccelerometer sharedAccelerometer];
    theAccel.updateInterval = 1.0f / 30.0f;
    theAccel.delegate = self;
    
    // ballMovement = CGPointMake(4, 4);
    // 初始化定时器
    // [self initializeTimer];
    
    [self loadGameState];
    
    [self initializeBricks];
    [self startPlaying];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void) initializeTimer
{
    //float theInterval = 1.0 / 30.0;
    //theTimer = [NSTimer scheduledTimerWithTimeInterval:theInterval
    //                                 target:self selector:@selector(gameLogic:)
    //                                 userInfo:nil repeats:YES];
    
    if(theTimer == nil) {
        theTimer = [CADisplayLink displayLinkWithTarget:self selector:@selector(gameLogic:)];
        //CADisplayLink默认每秒运行60次
        //设置间隔时间是2就是每秒运行30次
        theTimer.frameInterval = 2;
        [theTimer addToRunLoop: [NSRunLoop currentRunLoop] forMode:NSDefaultRunLoopMode];
    }
}

- (void) gameLogic:(NSTimer *)theTimer
{
    ball.center = CGPointMake(ball.center.x + ballMovement.x, ball.center.y + ballMovement.y);
    
    // 碰撞检测
    BOOL paddleCollision = ball.center.y >= paddle.center.y - 16 &&
            ball.center.y <= paddle.center.y + 16 &&
            ball.center.x > paddle.center.x - 32 &&
            ball.center.x < paddle.center.x + 32;
    
    if(paddleCollision)
        ballMovement.y = -ballMovement.y;
    
    //防止小球卡在木板中
    if(ball.center.y >= paddle.center.y - 16 && ballMovement.y < 0) {
        
        ball.center = CGPointMake(ball.center.x, ball.center.y - 16);
        
    } else if(ball.center.y <= paddle.center.y + 16 && ballMovement.y > 0) {
        
        ball.center = CGPointMake(ball.center.x, ball.center.y + 16);
        
    } else if(ball.center.x >= paddle.center.x - 32 && ballMovement.x < 0) {
        
        ball.center = CGPointMake(paddle.center.x - 32, ball.center.y);
        
    } else if(ball.center.x <= paddle.center.x + 32 && ballMovement.x > 0) {
        
        ball.center = CGPointMake(paddle.center.x + 32, ball.center.y);
        
    }
    
    BOOL there_are_solid_bricks = NO;
    
    for (int m = 0; m < BRICKS_HEIGHT; m++) {
        for (int n = 0; n < BRICKS_WIDTH; n++) {
            
            if(1.0 == bricks[n][m].alpha) {
                there_are_solid_bricks = YES;
                
                if(CGRectIntersectsRect(ball.frame, bricks[n][m].frame)) {
                    [self processCollision:bricks[n][m]];
                }
            } else {
                if(bricks[n][m].alpha > 0)
                    bricks[n][m].alpha -= 0.1;
            }
            
        }
    }

    if(!there_are_solid_bricks) {
        [self pauseGame];
        
        isPlaying = NO;
        lives = 0;
        
        // 保存游戏进度
        [self saveGameState];
        
        messageLabel.text = @"You Win";
        messageLabel.hidden = NO;
    }

    if(ball.center.x > 310 || ball.center.x < 16)
        ballMovement.x = -ballMovement.x;
    
    if(ball.center.y < 32)
        ballMovement.y = -ballMovement.y;
    
    if(ball.center.y > 444) {
        [self pauseGame];
        
        isPlaying = NO;
        lives--;
        livesLabel.text = [NSString stringWithFormat:@"Lives: %d", lives];
        
        if(!lives) {
            [self saveGameState];
            messagesLabel.text = @"Game Over";
        } else {
            messagesLabel.text = @"Out of Bounds";
        }
        
        messagesLabel.hidden = NO;
    }
}

// 加速传感器
- (void) accelermeter: (UIAccelerometer *)accelerommeter didAccelerate:(UIAcceleration *)accel
{
    float newX = paddle.center.x + (accel.x * 12);
    
    if(newX > 0 && newX < 290)
        paddle.center = CGPointMake(newX, paddle.center.y);
}

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    if(isPlaying) {
        UITouch * touch = [[event allTouches] anyObject];
        touchOffset = paddle.center.x - [touch locationInView:touch.view].x;
    } else {
        [self startPlaying];
    }
}

- (void) touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    if(isPlaying) {
        UITouch *touch = [[event allTouches] anyObject];
        
        float distanceMoved = [touch locationInView:touch.view].x + touchOffset - paddle.center.x;
        float newX = paddle.center.x + distanceMoved;
        
        if(newX > 30 && newX < 290)
            paddle.center = CGPointMake(newX, paddle.center.y);
        
        if(newX > 290)
            paddle.center = CGPointMake(290, paddle.center.y);
        
        if(newX < 30)
            paddle.center = CGPointMake(30, paddle.center.y);
    }
}

- (void) startPlaying
{
    if(!lives) {
        lives = 3;
        score = 0;
        
        for (int m = 0; m < BRICKS_HEIGHT; m++)
        {
            for (int n = 0; n < BRICKS_WIDTH; n++)
            {
                bricks[n][m].alpha = 1.0;
            }
        }
    }
	
    scoreLabel.text = [NSString stringWithFormat:@"%05d", score];
    livesLabel.text = [NSString stringWithFormat:@"Lives: %d", lives];
    
    ball.center = CGPointMake(159, 239);
    ballMovement = CGPointMake(4, 4);
    
    // 随机向左运动还是向右运动
    if(arc4random() % 100 < 50)
        ballMovement.x = -ballMovement.x;
    
    messagesLabel.hidden = YES;
    isPlaying = YES;
    
    [self initializeTimer];
}

- (void) pauseGame
{
    [theTimer invalidate];
    theTimer = nil;
}

- (void) initializeBricks
{
    for (int k = 0; k < BRICKS_HEIGHT; k++) {
        brickTypes[k] = [NSString stringWithFormat:@"bricktype%d", k + 1];
    }
    
    int count = 0;
    
    for (int m = 0; m < BRICKS_HEIGHT; m++) {
        for (int n = 0; n < BRICKS_WIDTH; n++) {
            UIImage *image = [UIImage imageNamed:brickTypes[count++ % 4]];
            bricks[n][m] = [[[UIImageView alloc] initWithImage:image] autorelease];
            CGRect newFrame = bricks[n][m].frame;
            newFrame.origin = CGPointMake(n * 64, (m * 40) + 100);
            bricks[n][m].frame = newFrame;
            [self.view addSubview:bricks[n][m]];
        }
    }
}

- (void) processCollision:(UIImageView *)brick
{
    score += 10;
    scoreLabel.text = [NSString stringWithFormat:@"%05d", score];
    
    // 集中了砖块的哪面，以相反的方向弹回
    if(ballMovement.x > 0 && brick.frame.origin.x - ball.center.x <= 4)
        ballMovement.x = -ballMovement.x;
    
    else if(ballMovement.x < 0 && ball.center.x - (brick.frame.origin.x + brick.frame.size.width) <= 4)
        ballMovement.x = -ballMovement.x;
    
    if(ballMovement.y > 0 && brick.frame.origin.y - ball.center.y <= 4)
        ballMovement.y = -ballMovement.y;
    
    else if(ballMovement.y < 0 && ball.center.y - (brick.frame.origin.y + brick.frame.size.height) <= 4)
        ballMovement.y = -ballMovement.y;
    
    brick.alpha -= 0.5;
}

NSString *kLivesKey = @"IVBrickerLives";
NSString *kScoreKey = @"IVBrickerScore";

- (void) saveGameState
{
    [[NSUserDefaults standardUserDefaults] setInteger:lives forKey:kLivesKey];
    [[NSUserDefaults standardUserDefaults] setInteger:score forKey:kScoreKey];
}

- (void) loadGameState
{
    lives = [[NSUserDefaults standardUserDefaults] integerForKey:kLivesKey];
    score = [[NSUserDefaults standardUserDefaults] integerForKey:kScoreKey];
    
    livesLabel.text = [NSString stringWithFormat:@"Lives: %d", lives];
    scoreLabel.text = [NSString stringWithFormat:@"%05d", score];
}

@end
